﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RoadTrain.Entities;

namespace RoadTrain.DrawingObjects
{
    public class DrawingRoadTrainWithTank : DrawingRoadTrain
    {
        public DrawingRoadTrainWithTank(int speed, double weight, Color bodyColor, Color
        additionalColor, bool pipes, bool section, int width, int height)
            : base(speed, weight, bodyColor, width, height, 200, 100)
        {
            if (EntityRoadTrain != null)
            {
                EntityRoadTrain = new EntityRoadTrainWithTank(speed, weight, bodyColor, additionalColor, pipes, section);
            }
        }
        public override void DrawTransport(Graphics g)
        {
            if (EntityRoadTrain is not EntityRoadTrainWithTank roadTrain)
            {
                return;
            }
            Pen pen = new(Color.Black, 2);
            Brush additionalBrush = new SolidBrush(roadTrain.AdditionalColor);
            base.DrawTransport(g);
            //щетка
            Brush brGray = new SolidBrush(Color.Gray);
            if (roadTrain.Brush)
            {
                g.DrawLine(pen, _startPosX + 160, _startPosY + 70, _startPosX + 180, _startPosY + 80);
                g.DrawRectangle(pen, _startPosX + 170, _startPosY + 80, 40, 10); //щетка
                g.FillRectangle(additionalBrush, _startPosX + 170, _startPosY + 80, 40, 10);
            }
            //бак
            if (roadTrain.Tank)
            {
                g.DrawRectangle(pen, _startPosX + 10, _startPosY, 90, 50); //бак с водой
                g.FillRectangle(additionalBrush, _startPosX + 10, _startPosY, 90, 50);
            }
        }
    }
}