﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RoadTrain.Generics
{
    internal class SetGeneric<T>
        where T : class
    {
        private readonly T?[] _places;
        public int Count => _places.Length;
        public SetGeneric(int count)
        {
            _places = new T?[count];
        }
        public int Insert(T roadtrain)
        {
            return Insert(roadtrain, 0);
        }
        public int Insert(T roadtrain, int position)
        {
            int nullIndex = -1;
            int i;

            if (position < 0 || position >= Count)
                return -1;

            for (i = position; i < Count; i++)
            {
                if (_places[i] == null)
                {
                    nullIndex = i;
                    break;
                }
            }
            if (nullIndex < 0)
                return -1;

            for (i = nullIndex; i > position; i--)
            {
                _places[i] = _places[i - 1];
            }
            _places[position] = roadtrain;
            return position;
        }
        public bool Remove(int position)
        {
            if (position < 0 || position >= Count)
            {
                return false;
            }
            _places[position] = null;
            return true;
        }
        public T? Get(int position)
        {
            if (position < 0 || position >= Count)
            {
                return null;
            }
            return _places[position];
        }
    }
}