﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using RoadTrain.DrawingObjects;
using RoadTrain.Generics;
using RoadTrain.MovementStrategy;


namespace RoadTrain
{
    public partial class TrainCollection : Form
    {

        private readonly TrainsGenericCollection<DrawingRoadTrain,
        DrawingObjectTrain> _trains;
        public TrainCollection()
        {
            InitializeComponent();
            _trains = new TrainsGenericCollection<DrawingRoadTrain, DrawingObjectTrain>
                (pictureBoxCollection.Width, pictureBoxCollection.Height);
        }
        private void ButtonAddTrain_Click(object sender, EventArgs e)
        {
            RoadTrain form = new();
            if (form.ShowDialog() == DialogResult.OK)
            {
                if (_trains + form.SelectedTrain != -1)
                {
                    MessageBox.Show("Объект добавлен");
                    pictureBoxCollection.Image = _trains.ShowTrains();
                }
                else
                {
                    MessageBox.Show("Не удалось добавить объект");
                }
            }
        }
        private void ButtonRemoveTrain_Click(object sender, EventArgs e)
        {
            if (MessageBox.Show("Удалить объект?", "Удаление",
            MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.No)
            {
                return;
            }
            int pos = Convert.ToInt32(maskedTextBoxNumber.Text);
            if (_trains - pos != null)
            {
                MessageBox.Show("Объект удален");
                pictureBoxCollection.Image = _trains.ShowTrains();
            }
            else
            {
                MessageBox.Show("Не удалось удалить объект");
            }
        }
        private void ButtonRefreshCollection_Click(object sender, EventArgs e)
        {
            pictureBoxCollection.Image = _trains.ShowTrains();
        }
    }
}